rem 7upLight by gehtnix  13.11.2009
rem Abgespecktes sevenup
@title 7upLight
@param a Anzahl Bilder (Faktor 100)
@default a 0
@param b Anzahl Bilder (Faktor 10)
@default b 1
@param c Anzahl Bilder (Faktor 1)
@default c 0
@param d Intervall (min)
@default d 0
@param e Intervall (sec)
@default e 2
@param f Bild-Kompression (0,1,2)
@default f 0
@param g Bild-Pixel (0,1,2,4,6,8)
@default g 0
@param i LCD aus nach x Bildern
@default i 2
@param o K. mit Sucher 0=ja 1=nein
@default o 0
@param p Sleep f. Backlight (x10ms)
@default p 25
@param j AkkuStop bei mV
@default j 4400
@param m AkkuStop 0=aus 1=ein
@default m 0
@param q Bearbeitungszeit 1/100
@default q 6
@param n Kamera aus 0=nein 1=ja
@default n 0
@param l AF-Lock 0=aus 1=ein
@default l 0

if m=0 then j=0

L=get_resolution
M=get_quality
  
rem --- minimale Kamerazeit
Q=1000+(q*100)

set_aflock 0
cls
gosub "intervall"
goto "restore"

end

:intervall
	set_quality f
	set_resolution g
	
	X=get_display_mode

	rem --- stckzahl
	S=a*100+b*10+c

	rem --- intervall
	T=d*60000+e*1000
	if a<0 then a=0
	if b<0 then b=0
	if c<0 then c=0
	if T<1000 then T=1000

	rem --- Startzeit
	A=(x*3600)+(y*60)
	B=get_day_seconds

	if T<=Q then I=B+(S*Q/1000)
	if T>Q then I=B+(S*T/1000)
	gosub "stunde"
	if D>24 then D=D-24
	print "************************"
	print "Fotoanzahl:", S
	if T<=Q then
		print "Gesamtzeit:",(d*60000+Q)*S/60000,"min", (d*60000+Q)*S%60000/1000,"sec"
		print "Fertig um :",D,":",E, " Uhr"
	else
		print "Fotozeit  :",T*S/60000,"min", T*S%60000/1000,"s"
		print "Fertig um :",D,":",E,"Uhr"
	endif
	sleep 5000

	rem af_lock setzen
	if l=1 then
		press "shoot_half"
		sleep 500
		set_aflock 1
		release "shoot_half"
	endif

	N=get_tick_count

rem ----------- Intervall
	select T
		case 0 to Q; R=0
		case_else R=T
	end_select
	for J=1 to S
		if get_vbatt<j or get_free_disk_space<5000 then gosub "Akkustop"
		cls
		print "************************"
		print "Bild ", J, "von", S
		shoot
		if J=i then 
			cls
			if o=0 then gosub "dispaus"
			if R=0 then
				for K=J+1 to S
					shoot
					P=get_usb_power
					if P>0 then goto "restore"
				next K
				goto "restore"
			endif 
		endif
		if J=S then goto "restore"
		print "Warte", d, "min", e, "sec"
		if o=1 and J>=i and J<(S-i) then
			sleep p*10
			set_backlight 0
		endif
		N=N+R
		do
			P=get_usb_power
			if P>0 then goto "restore"
		until get_tick_count>=N	
		if o=0 and J>=(S-i) then gosub "dispein"
	next J
	return

:stunde
	B=I
	C=B/60
	D=C/60
	E=C-(D*60)
	F=B-(C*60)
	if F>25 then E=E+1
	return

:dispaus
	do
		click "display"
		U=get_display_mode
		sleep 200
	until (U=2 or U=3)
	return

:dispein
	do
		click "display"
		U=get_display_mode
		sleep 200
	until U=X
	return

:Akkustop
	cls
	print "Akku mit zu wenig Strom"
	print "o. zu wenig SD-Platz"
	print "Schalte Kamera aus."
	sleep 3000
	n=1
	goto "restore"
	return

:restore
	cls
	gosub "dispein"
	set_quality M
	set_resolution L
	set_aflock 0
	set_raw 0
	if n=1 then
		shut_down
		sleep 3000
	endif
	exit_alt
	end
